#ifndef __socket_h
#define __socket_h

#include "filed.h"

/* std */

void c_send(struct connection *c, char *data, ...);
int c_send_to(int id, char *data, ...);
void c_disconnect(struct connection *c);
void c_hangup(struct connection *c);

struct connection *get_connection_by_id(int id);
struct connection *get_connection_by_name(char *name);
int get_connection_id_by_name(char *name);

void bind_socket(void);
void handle_connections(void);

int check_access(char *addr);
void write_connection(struct connection *c);
void read_connection(struct connection *c);
void err_connection(struct connection *c);

void accept_connection(void);
void insert_connection(struct connection *c);
void remove_connection(struct connection *c);
void free_connection(struct connection *c);
struct connection *new_connection(int fd, char *addr);
struct connection *connect_to(char *addr, int port);

int pending_tx(struct connection *c);
int pending_rx(struct connection *c);
int gone_away(struct connection *c);

char *c_str_flags(int flags);
char *c_str_type(int type);


/* connection flags */

#define CFLAG_NEW 2
#define CFLAG_GONE_AWAY 4
#define CFLAG_NEWTX 8
#define CFLAG_NODATA 16
#define CFLAG_IDENTIFIED 32

/* queue flags */

#define QFLAG_DISCONNECT 2
#define QFLAG_HANGUP 4
#define QFLAG_INPROGRESS 8

#endif
